/*******************************************************


AVR Core Clock frequency: 1,000000 MHz

*******************************************************/

#include <mega8.h>
#include <delay.h>
unsigned char pover=127; 
unsigned char vkl=0;
unsigned char kn=1;
unsigned char flage=0;
unsigned char flag2=0;
unsigned char a=0; 
unsigned char amem=0;
unsigned char pauza=0;

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{

a=!a;
pauza=(255-pover);
 if (a==1) {TCNT0=pover;};
 if (a==0) {TCNT0=pauza;};
  PORTB.0=a;
}

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Reinitialize Timer1 value
TCNT1H=0xC2F7 >> 8;
TCNT1L=0xC2F7 & 0xff;
// Place your code here
flage=1;
TCCR1B=0x00;
DDRC=(0<<DDC0);
}

void main(void)
{


DDRB=(1<<DDB7) | (1<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);

PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

 
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);

PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);


DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (1<<DDD0);
 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

TCCR0=(1<<CS02) | (0<<CS01) | (0<<CS00);
TCNT0=0x00;


TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (1<<CS11) | (1<<CS10);
TCNT1H=0xC2;
TCNT1L=0xF7;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;


ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (0<<CS22) | (0<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2=0x00;

TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (1<<TOIE1) | (1<<TOIE0);



// Global enable interrupts
#asm("sei")

while (1)
      {
       kn=PINC.0;
       
         if ((kn==0)&(flage==0)) {DDRC=(1<<DDC0);flag2=0;
         TCCR1B= (0<<CS12) | (1<<CS11) | (1<<CS10);        
        };
        
           if ((flage==1)&(kn==1)){
           flage=0;
           vkl=!vkl;
             if (flag2==0) {  
             if (vkl==0) 
              {pover=1;};
              if (vkl==1)
               {pover=254;};                                           
              };   
               
       
           };
       
         if ((flage==1)&(kn==0)) {
          flag2=1;
           if (a!=amem) { amem=a;
           switch (vkl) {            
          case 0: pover=pover+1;
          if (pover==254) {vkl=!vkl;}; 
          break;
          
          case 1:pover=pover-1;
           if (pover==1) {vkl=!vkl;}; 
          break;
          }; 
         }; 
        };
       
           
      };
};












